import numpy as np
import pandas as pd

rng = np.random.default_rng()

fin_nm = input('Input Data File (*.csv) = ')  

df_data = pd.read_csv(fin_nm)

print(df_data)

df_data_val = np.array(df_data.values, dtype=int)
print(df_data_val)
"""
      素データをまとめるための辞書型変数の作成
"""
dict_data = {}
for v in df_data_val:
    a = v[1]
    b = v[2]
    if a > b:
        a, b = b, a
    c = v[3]
    d = v[4]
    if c > d:
        c, d = d, c
    X = v[5]
    a = int(a)
    b = int(b)
    c = int(c)
    d = int(d)
    if rng.random() < 0.5:
        a, b, c, d = c, d, a, b
        X = 0 if X ==1 else 1

    if (a, b, c, d) in dict_data:
        dict_data[(a, b, c, d)]['TN'] += 1
        if X == 1:
            dict_data[(a, b, c, d)]['N'] += 1
    else:
        if X == 1:
            dict_data[(a, b, c, d)] = {'TN':1, 'N':1}
        else:
            dict_data[(a, b, c, d)] = {'TN':1, 'N':0}        

print(dict_data)
"""
      (i,j)と(s,t)の比較と、(s,t)と(i,j)の比較データをまとめる
"""
ck_dict = {}
for k in dict_data.keys():
    ki, kj, ks, kt = k
    N = dict_data[k]['N']
    TN = dict_data[k]['TN']
    if not k in ck_dict.keys():
        if (ks, kt, ki, kj) in ck_dict.keys():
            ck_dict[(ks, kt, ki, kj)]['N'] += TN - N
            ck_dict[(ks, kt, ki, kj)]['TN'] += TN
        else:
            ck_dict[k] = {'N':N, 'TN':TN}

dict_data = ck_dict

"""
       まとめたデータをCSV形式のファイルとして出力
"""
for k in dict_data.keys():
    print(k, dict_data[k])
n_st = int(input('Number of stimuli = '))
fout_nm = input('Output File Name (*.csv) = ')
with open(fout_nm, 'w') as f:
    f.write(f'{n_st},,,,,\n')
    f.write('i,j,s,t,N,TN\n')
    for k in dict_data.keys():
        i = k[0]
        j = k[1]
        s = k[2]
        t = k[3]
        TN = dict_data[k]['TN']
        N = dict_data[k]['N']
        f.write(f'{i},{j},{s},{t},{N},{TN}\n')

        


    
